package dev.shadowsoffire.apotheosis.village.wanderer;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.trades.AffixTrade;
import dev.shadowsoffire.apotheosis.village.VillageModule;
import dev.shadowsoffire.apotheosis.village.wanderer.JsonTrade;
import dev.shadowsoffire.apotheosis.village.wanderer.WandererTrade;
import dev.shadowsoffire.placebo.reload.DynamicRegistry;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.npc.VillagerTrades;
import net.minecraftforge.common.BasicItemListing;

public class WandererTradesRegistry extends DynamicRegistry<JsonTrade> {
  public static final dev.shadowsoffire.apotheosis.village.wanderer.WandererTradesRegistry INSTANCE = new dev.shadowsoffire.apotheosis.village.wanderer.WandererTradesRegistry();
  
  protected final Map<ResourceLocation, BasicItemListing> registry = new HashMap<>();
  
  protected final List<VillagerTrades.ItemListing> normTrades = new ArrayList<>();
  
  protected final List<VillagerTrades.ItemListing> rareTrades = new ArrayList<>();
  
  public WandererTradesRegistry() {
    super(VillageModule.LOGGER, "wanderer_trades", false, true);
  }
  
  protected void registerBuiltinCodecs() {
    registerDefaultCodec(Apotheosis.loc("basic_trade"), WandererTrade.CODEC);
    registerCodec(Apotheosis.loc("affix"), AffixTrade.CODEC);
  }
  
  protected void beginReload() {
    super.beginReload();
    this.normTrades.clear();
    this.rareTrades.clear();
  }
  
  protected void onReload() {
    super.onReload();
    getValues().forEach(trade -> {
          if (trade.isRare()) {
            this.rareTrades.add(trade);
          } else {
            this.normTrades.add(trade);
          } 
        });
  }
  
  public List<VillagerTrades.ItemListing> getNormalTrades() {
    return this.normTrades;
  }
  
  public List<VillagerTrades.ItemListing> getRareTrades() {
    return this.rareTrades;
  }
}
